#include <bits/stdc++.h>


using namespace std;
ifstream f1("strd4.inp");
ofstream f2("strd4.out");


int main()
{ string s,x;
int i,dem=0,j;
 f1>>s;
 for(i=s.length()-1;i>=0;i--)
 {   if (s[i]%2==0){ for (j=i;j>=i-1;j--)
    {x=s[j]+x; if (atoi(x.c_str())%4==0) {if (j==i-1) {dem=dem+i;} else dem++;}}x="";}


 }
 f2<<dem;

    return 0;
}
